'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _EventTarget2 = require('./EventTarget.js');

var _EventTarget3 = _interopRequireDefault(_EventTarget2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable */


var _url = new WeakMap();
var _method = new WeakMap();
var _requestHeader = new WeakMap();
var _responseHeader = new WeakMap();
var _requestTask = new WeakMap();

var fs = void 0;

function _triggerEvent(type) {
    var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    event.target = event.target || this;

    if (typeof this['on' + type] === 'function') {
        this['on' + type].call(this, event);
    }
}

function _changeReadyState(readyState) {
    var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    this.readyState = readyState;

    event.readyState = readyState;

    _triggerEvent.call(this, 'readystatechange', event);
}

function _isRelativePath(url) {
    return !/^(http|https|ftp|wxfile):\/\/.*/i.test(url);
}

var XMLHttpRequest = function (_EventTarget) {
    _inherits(XMLHttpRequest, _EventTarget);

    function XMLHttpRequest() {
        _classCallCheck(this, XMLHttpRequest);

        /*
         * TODO 这一批事件应该是在 XMLHttpRequestEventTarget.prototype 上面的
         */
        var _this = _possibleConstructorReturn(this, (XMLHttpRequest.__proto__ || Object.getPrototypeOf(XMLHttpRequest)).call(this));

        _this.onabort = null;
        _this.onerror = null;
        _this.onload = null;
        _this.onloadstart = null;
        _this.onprogress = null;
        _this.ontimeout = null;
        _this.onloadend = null;

        _this.onreadystatechange = null;
        _this.readyState = 0;
        _this.response = null;
        _this.responseText = null;
        _this.responseType = '';
        _this.responseXML = null;
        _this.status = 0;
        _this.statusText = '';
        _this.upload = {};
        _this.withCredentials = false;

        _requestHeader.set(_this, {
            'content-type': 'application/x-www-form-urlencoded'
        });
        _responseHeader.set(_this, {});
        return _this;
    }

    _createClass(XMLHttpRequest, [{
        key: 'abort',
        value: function abort() {
            var myRequestTask = _requestTask.get(this);

            if (myRequestTask) {
                myRequestTask.abort();
            }
        }
    }, {
        key: 'getAllResponseHeaders',
        value: function getAllResponseHeaders() {
            var responseHeader = _responseHeader.get(this);

            return Object.keys(responseHeader).map(function (header) {
                return header + ': ' + responseHeader[header];
            }).join('\n');
        }
    }, {
        key: 'getResponseHeader',
        value: function getResponseHeader(header) {
            return _responseHeader.get(this)[header];
        }
    }, {
        key: 'open',
        value: function open(method, url /* async, user, password 这几个参数在小程序内不支持*/) {
            _method.set(this, method);
            _url.set(this, url);
            _changeReadyState.call(this, XMLHttpRequest.OPENED);
        }
    }, {
        key: 'overrideMimeType',
        value: function overrideMimeType() {}
    }, {
        key: 'send',
        value: function send() {
            var _this2 = this;

            var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

            if (this.readyState !== XMLHttpRequest.OPENED) {
                throw new Error("Failed to execute 'send' on 'XMLHttpRequest': The object's state must be OPENED.");
            } else {
                var url = _url.get(this);
                var header = _requestHeader.get(this);
                var responseType = this.responseType;

                var relative = _isRelativePath(url);
                var encoding = void 0;

                if (responseType === 'arraybuffer') {
                    // encoding = 'binary'
                } else {
                    encoding = 'utf8';
                }

                delete this.response;
                this.response = null;

                var onSuccess = function onSuccess(_ref) {
                    var data = _ref.data,
                        statusCode = _ref.statusCode,
                        header = _ref.header;

                    statusCode = statusCode === undefined ? 200 : statusCode;
                    if (typeof data !== 'string' && !(data instanceof ArrayBuffer)) {
                        try {
                            data = JSON.stringify(data);
                        } catch (e) {
                            data = data;
                        }
                    }

                    _this2.status = statusCode;
                    if (header) {
                        _responseHeader.set(_this2, header);
                    }
                    _triggerEvent.call(_this2, 'loadstart');
                    _changeReadyState.call(_this2, XMLHttpRequest.HEADERS_RECEIVED);
                    _changeReadyState.call(_this2, XMLHttpRequest.LOADING);

                    _this2.response = data;

                    if (data instanceof ArrayBuffer) {
                        Object.defineProperty(_this2, 'responseText', {
                            enumerable: true,
                            configurable: true,
                            get: function get() {
                                throw "InvalidStateError : responseType is " + this.responseType;
                            }
                        });
                    } else {
                        Object.defineProperty(_this2, 'responseText', {
                            enumerable: true,
                            configurable: true,
                            value: data
                        });
                    }
                    _changeReadyState.call(_this2, XMLHttpRequest.DONE);
                    _triggerEvent.call(_this2, 'load');
                    _triggerEvent.call(_this2, 'loadend');
                };

                var onFail = function onFail(_ref2) {
                    var errMsg = _ref2.errMsg;

                    // TODO 规范错误

                    if (errMsg.indexOf('abort') !== -1) {
                        _triggerEvent.call(_this2, 'abort');
                    } else {
                        _triggerEvent.call(_this2, 'error', {
                            message: errMsg
                        });
                    }
                    _triggerEvent.call(_this2, 'loadend');

                    if (relative) {
                        // 用户即使没监听error事件, 也给出相应的警告
                        console.warn(errMsg);
                    }
                };

                if (relative) {
                    var options = {
                        'filePath': url,
                        'success': onSuccess,
                        'fail': onFail
                    };
                    if (encoding) {
                        options['encoding'] = encoding;
                    }
                    if (!fs) {
                        fs = swan.getFileSystemManager();
                    }
                    fs.readFile(options);
                    return;
                }

                swan.request({
                    data: data,
                    url: url,
                    method: _method.get(this),
                    header: header,
                    responseType: responseType,
                    success: onSuccess,
                    fail: onFail
                });
            }
        }
    }, {
        key: 'setRequestHeader',
        value: function setRequestHeader(header, value) {
            var myHeader = _requestHeader.get(this);

            myHeader[header] = value;
            _requestHeader.set(this, myHeader);
        }
    }, {
        key: 'addEventListener',
        value: function addEventListener(type, listener) {
            var _this3 = this;

            if (typeof listener !== 'function') {
                return;
            }

            this['on' + type] = function () {
                var event = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

                event.target = event.target || _this3;
                listener.call(_this3, event);
            };
        }
    }, {
        key: 'removeEventListener',
        value: function removeEventListener(type, listener) {
            if (this['on' + type] === listener) {
                this['on' + type] = null;
            }
        }
    }]);

    return XMLHttpRequest;
}(_EventTarget3.default);

// TODO 没法模拟 HEADERS_RECEIVED 和 LOADING 两个状态


exports.default = XMLHttpRequest;
XMLHttpRequest.UNSEND = 0;
XMLHttpRequest.OPENED = 1;
XMLHttpRequest.HEADERS_RECEIVED = 2;
XMLHttpRequest.LOADING = 3;
XMLHttpRequest.DONE = 4;
module.exports = exports['default'];