'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isDevtool = require('./util/isDevtool');

var _isDevtool2 = _interopRequireDefault(_isDevtool);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var performance = void 0; /* eslint-disable */


if (swan.getPerformance) {
  var swanPerf = swan.getPerformance();
  var initTime = swanPerf.now();

  var clientPerfAdapter = Object.assign({}, swanPerf, {
    now: function now() {
      return (swanPerf.now() - initTime) / 1000;
    }
  });

  performance = (0, _isDevtool2.default)() ? swanPerf : clientPerfAdapter;
} else {
  performance = {};
  performance.now = Date.now;
}

exports.default = performance;
module.exports = exports['default'];