'use strict';

var Audio = cc.Audio;

if (Audio) {
    Object.assign(Audio.prototype, {
        play: function play() {
            // marked as playing so it will playOnLoad
            this._state = Audio.State.PLAYING;

            if (!this._element) {
                return;
            }

            this._bindEnded();
            this._element.play();
        },
        destroy: function destroy() {
            this._element && this._element.destroy();

            this._element = null;
        },
        setCurrentTime: function setCurrentTime(num) {
            if (this._element) {
                this._nextTime = 0;
            } else {
                this._nextTime = num;
                return;
            }

            this._unbindEnded();

            this._bindEnded(function () {
                this._bindEnded();
            }.bind(this));

            try {
                this._element.currentTime = num;
            } catch (err) {
                var _element = this._element;
                if (_element.addEventListener) {
                    var func = function func() {
                        _element.removeEventListener('loadedmetadata', func);
                        _element.currentTime = num;
                    };
                    _element.addEventListener('loadedmetadata', func);
                }
            }
        },
        getState: function getState() {
            return this._state;
        }
    });
}